"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports["default"]=void 0;var _buildReducer=_interopRequireDefault(require("../lib/buildReducer"));var _ramda=require("ramda");var ActionTypes=_interopRequireWildcard(require("./actionTypes"));var _actionHandlers;function _interopRequireWildcard(obj){if(obj&&obj.__esModule){return obj}else{var newObj={};if(obj!=null){for(var key in obj){if(Object.prototype.hasOwnProperty.call(obj,key)){var desc=Object.defineProperty&&Object.getOwnPropertyDescriptor?Object.getOwnPropertyDescriptor(obj,key):{};if(desc.get||desc.set){Object.defineProperty(newObj,key,desc)}else{newObj[key]=obj[key]}}}}newObj["default"]=obj;return newObj}}function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{"default":obj}}function _defineProperty(obj,key,value){if(key in obj){Object.defineProperty(obj,key,{value:value,enumerable:true,configurable:true,writable:true})}else{obj[key]=value}return obj}function _toConsumableArray(arr){return _arrayWithoutHoles(arr)||_iterableToArray(arr)||_nonIterableSpread()}function _nonIterableSpread(){throw new TypeError("Invalid attempt to spread non-iterable instance")}function _iterableToArray(iter){if(Symbol.iterator in Object(iter)||Object.prototype.toString.call(iter)==="[object Arguments]")return Array.from(iter)}function _arrayWithoutHoles(arr){if(Array.isArray(arr)){for(var i=0,arr2=new Array(arr.length);i<arr.length;i++){arr2[i]=arr[i]}return arr2}}var initialState={};var removeFirstOccurrence=function removeFirstOccurrence(value){return function(list){return(0,_ramda.remove)(list.indexOf(value),1,list)}};var removeLastOccurrence=function removeLastOccurrence(value){return function(list){return(0,_ramda.remove)(list.lastIndexOf(value),1,list)}};function removeNOccurrences(){var list=arguments.length>0&&arguments[0]!==undefined?arguments[0]:[];var count=arguments.length>1&&arguments[1]!==undefined?arguments[1]:0;var value=arguments.length>2?arguments[2]:undefined;if(count===0){return list.filter(function(item){return item!==value})}else{var fn=count<0?removeLastOccurrence:removeFirstOccurrence;var functions=(0,_ramda.repeat)(fn(value),Math.abs(count));return _ramda.pipe.apply(void 0,_toConsumableArray(functions))(list)}}var actionHandlers=(_actionHandlers={},_defineProperty(_actionHandlers,ActionTypes.UNSHIFT,function(state,action){var _action$payload=action.payload,domain=_action$payload.domain,value=_action$payload.value;var prevItems=(0,_ramda.propOr)([],domain,state);return(0,_ramda.assoc)(domain,[value].concat(_toConsumableArray(prevItems)),state)}),_defineProperty(_actionHandlers,ActionTypes.PUSH,function(state,action){var _action$payload2=action.payload,domain=_action$payload2.domain,value=_action$payload2.value;var prevItems=(0,_ramda.propOr)([],domain,state);return(0,_ramda.assoc)(domain,[].concat(_toConsumableArray(prevItems),[value]),state)}),_defineProperty(_actionHandlers,ActionTypes.SHIFT,function(state,action){var domain=action.payload.domain;var newList=(0,_ramda.propOr)([],domain,state);return(0,_ramda.assoc)(domain,(0,_ramda.tail)(newList),state)}),_defineProperty(_actionHandlers,ActionTypes.POP,function(state,action){var domain=action.payload.domain;var list=(0,_ramda.propOr)([],domain,state);return(0,_ramda.assoc)(domain,(0,_ramda.init)(list),state)}),_defineProperty(_actionHandlers,ActionTypes.REPLACE_ONE,function(state,action){var _action$payload3=action.payload,domain=_action$payload3.domain,value=_action$payload3.value,index=_action$payload3.index;var prevItems=(0,_ramda.propOr)([],domain,state);return(0,_ramda.assoc)(domain,(0,_ramda.update)(index,value,prevItems),state)}),_defineProperty(_actionHandlers,ActionTypes.REPLACE_DOMAIN,function(state,action){var _action$payload4=action.payload,domain=_action$payload4.domain,elements=_action$payload4.elements;return(0,_ramda.assoc)(domain,_toConsumableArray(elements),state)}),_defineProperty(_actionHandlers,ActionTypes.REMOVE_OCCURRENCES,function(state,action){var _action$payload5=action.payload,domain=_action$payload5.domain,count=_action$payload5.count,value=_action$payload5.value;var prevItems=(0,_ramda.propOr)([],domain,state);return(0,_ramda.assoc)(domain,removeNOccurrences(prevItems,count,value),state)}),_defineProperty(_actionHandlers,ActionTypes.TRIM,function(state,action){var _action$payload6=action.payload,domain=_action$payload6.domain,start=_action$payload6.start,stop=_action$payload6.stop;var prevItems=(0,_ramda.propOr)([],domain,state);return(0,_ramda.assoc)(domain,(0,_ramda.slice)(start,stop+1,prevItems),state)}),_actionHandlers);var _default=(0,_buildReducer["default"])(initialState,actionHandlers);exports["default"]=_default;